#include <GL/gl.h>
#include <inttypes.h>
#include "gl.h"
#include <strings.h>
#include <assert.h>
#include "gl.h"
/* do wywalenia */
#include <X11/Xlib.h>
#include <GL/glx.h>
#include <stdio.h>
#include <stdlib.h>

#include <signal.h>
#include <unistd.h>

/* co zrobic pozniej: */
/* 1: przesniesc obliczanie TP i CLUT'a do funkcji prepare_texture */
/* 2: przemyslec co z maskami */
/* 3: zoptymalizowac calosc (bcopy, wszystko przez dataMem) */
/* 4: dodac opsluge MDEC */ 
/* 5: sprawdzic jak podac koordynaty tekstur integralnie i zaimplementowac */
/* 6: dodac do writeData test czy funkcja jest pomiedzy 0x20 a 0x7f */
/* i przycinajacy 2 ostatie bity w takim przypadku */
/* oraz ustawiajacy odpowiednio Blend'owanie */
/* (byc moze przez dodatkowa funkcje z gl.c */
/* 7: ustawic texture border i wyczaic czemu sa przesuniecia */
/* na poczatkowym ekranie */
/* 8: sprawdzic to: (set mask) */
/* lGPUstatusRet&=~0x1800; */
/* lGPUstatusRet|=(((ulong)gdata & 0x03) << 11); */
/* zastosowane w cmdSTP */
/* 9: sprawdzic jakie w praktyce dlugie moga byc polylinie */
/* i ewentualnie przniesc cala ich obsluge do odpowiednich funkcji */
/* w gpu.c zostawiajac jedynie buforowanie */
/* 10: zanim zaczne sie bawic z Blend'em, dopracowac obecna wersje */
/* dla tych funkcji dla ktorych jest juz wlaczony */
/* 11: update period when PSX don't want to change display (every 5th VSync) */


/* XXX wymyslic wreszcie porzadne nazwy dla tych zmiennych */
int testdrx, testdry;
int testenx, testeny;

int
check_transfer(int x, int y, int xe, int ye)
{
	if (((testdrx <= x && x <= testenx) ||
		 (testdrx <= xe && xe <= testdrx)) &&
		/* X in */
		((testdry <= y && y <= testeny) ||
		 (testdry <= ye && ye <= testeny))) {
		/* Y in */
		printf("gl.c: check_transfer: we found a transfer directly to VIDEO MEMORY\n");
		printf("gl.c: check_transfer: x=%d y=%d xe=%d ye=%d\n",
			   x, y, xe, ye);
		printf("gl.c: check_transfer: video_memory: x=%d y=%d xe=%d ye=%d\n",
			   testdrx, testdry, testenx, testeny);

		return 1;
	}
	return 0;
}

static void
reset(input_t *data)
{

}

static
void
remove_textures(int, int, int, int);

static void
put_image(input_t *data)
{
	vty = data[1].w[1];
	vtxs = data[1].w[0];
	vtx = vtxs;
	vtye = data[2].w[1] + vty;
	vtxe = data[2].w[0] + vtx;
	image_transfer = 1;

	assert(vtxe <= MAXX);
	assert(vtye <= MAXY);
	/* add some error checking */
	check_transfer(vtx, vty, vtxe, vtye);
#ifdef DEBUG
	printf("gl.c: put_image: window size: %dx%d=%d\n",
		   data[2].w[0], data[2].w[1], data[2].w[0]*data[2].w[1]);
	printf("gl.c: put_image: vtx=%d vty=%d vtxe=%d vtye=%d\n",
		   vtx, vty, vtxe, vtye);
#endif
	remove_textures(vtx, vty, vtxe, vtye);
	trcnt = 0;
}

static void
get_image(input_t *data)
{
	vty = data[1].w[1];
	vtxs = data[1].w[0];
	vtx = vtxs;
	vtye = data[2].w[1] + vty;
	vtxe = data[2].w[0] + vtx;
	image_transfer = 2;
	assert(vtxe < MAXX);
	assert(vtye <= MAXY);
#ifdef DEBUG
	printf("gl.c: get_image: window size: %dx%d=%d\n",
		   data[2].w[0], data[2].w[1], data[2].w[0]*data[2].w[1]);
	printf("gl.c: get_image: vtx=%d vty=%d vtxe=%d vtye=%d\n",
		   vtx, vty, vtxe, vtye);
#endif
	check_status = 1;
	gpu_status |= 0x08000000;
	trcnt = 0;
}

static void
move_image(input_t *data)
{
	uint16_t source_y = data[1].w[1];
	uint16_t source_x = data[1].w[0];
	uint16_t destination_y = data[2].w[1];
	uint16_t destination_x = data[2].w[0];
	uint16_t height = data[3].w[1];
	uint16_t width = data[3].w[0];
	int i, j;

#ifdef DEBUG
	printf("gl.c: move_image: (%d,%d)->(%d,%d) (%d,%d)\n", 
		   source_x, source_y, destination_x, destination_y,
		   width, height);
#endif
	/* __asm__("int $3\n"); */
	assert(width > 0);
	assert(height > 0);
	assert(source_x + width < MAXX);
	assert(source_y + height < MAXY);
	assert(destination_x + width < MAXX);
	assert(destination_y + height < MAXY);

	check_transfer(destination_x, destination_y, destination_x + width,
				   destination_y + height);
#if 0
	for (i = 0; i < width; i++)
		/*
		printf("gl.c: move_image: %d moving %d to %d (0x%x)\n",
			   i, source_x + i, destination_x + i, vram[source_x][0]);
		*/
		bcopy(&vram[destination_x + i][destination_y], &vram[source_x + i][source_y],
			  sizeof(uint16_t) * height);
#endif
#if 1
	for(j = 0; j < height; j++)
		for(i = 0; i < width; i++)
			vram[destination_x + i][destination_y + j] = vram[source_x + i][source_y + j];
#endif
	remove_textures(destination_x, destination_y,
					destination_x + width, destination_y + height);
}

/* set drawing area top left */
static void
darea_tl(input_t *data)
{
	GLdouble clip[4];
	int x = data[0].dw & 0x3ff;
	int y = (data[0].dw >> 0xa) & 0x3ff;

#ifdef DEBUG_VIDEO
	if (testdrx != x || testdry != y)
		printf("gl.c: darea_tl: x=%d, y=%d (0x%.6x)\n", x, y, data[0].dw);
#endif
	testdrx = x;
	testdry = y;
#if 1
	clip[0] = 1; clip[1] = 0; clip[2] = 0; clip[3] = -x;
	glClipPlane(GL_CLIP_PLANE0, clip);
	clip[0] = 0; clip[1] = 1; clip[2] = 0; clip[3] = -y;
	glClipPlane(GL_CLIP_PLANE1, clip);
#endif
}

/* set drawing area bottom right */
static void
darea_br(input_t *data)
{
	/* GLdouble clip[4]; */
	int x = data[0].dw & 0x3ff;
	int y = (data[0].dw >> 0xa) & 0x3ff;

#ifdef DEBUG_VIDEO
	if (testenx != x || testeny != y)
		printf("gl.c: darea_br: x=%d y=%d (0x%.6x)\n", x, y, data[0].dw);
#endif
	testenx = x;
	testeny = y;
#if 0
	clip[0] = -1; clip[1] = 0; clip[2] = 0; clip[3] = x;
	glClipPlane(GL_CLIP_PLANE2, clip);
	clip[0] = 0; clip[1] = -1; clip[2] = 0; clip[2] = y;
	glClipPlane(GL_CLIP_PLANE3, clip);
#endif
}

/* set drawing offset */
static void
darea_of(input_t *data)
{
	/*static int off_x = 0, off_y = 0;*/
	int x, y;

	x = data[0].dw & 0x7ff;
	y = (data[0].dw >> 0xb) & 0x3ff;
#ifdef DEBUG
	printf("gl.c: darea_of: x=%d y=%d (0x%.6x)\n", x, y, data[0].dw);
#endif

#if 0
	if (x != off_x || y != off_y) {
		 glLoadIdentity(); 
		/*
		glTranslatef(-off_x, -off_y, 0);
		*/
		glTranslatef(-x, -y, 0);
		
		off_x = x; off_y = y;
	}
#endif
}

/* set drawing mask */
static void
set_mask(input_t *data)
{
#ifdef DEBUG
	printf("gl.c: set_mask data=0x%X\n", data[0].dw);
#endif
	gpu_status &= ~3;
	gpu_status |= data[0].dw;
}

static void
clear_cache(input_t *data)
{

}

static void
frame_draw(input_t *data)
{
#if 0
	int16_t x = data[1].w[0], y = data[1].w[1];
	int16_t w = data[2].w[0], h = data[1].w[1];
 
	glRects(x, y, x + w, y + h);
#endif
}

int global_tpx, global_tpy, global_clut_type;
int global_abr; 
static void
texture_page(input_t *data)
{
#if 1
	uint16_t tpage = data[0].w[0];

	global_tpx = (tpage & 0xf) << 6;
	global_tpy = tpage & 0x10 ? 256 : 0;
	global_clut_type = (tpage & 0x180) >> 7;
	global_abr = (tpage >> 5) & 0x3;
#endif
}

static void
texture_window(input_t *data)
{

}

static int ntextures = 0;
static struct {
	int16_t tx;
	int16_t ty;
	int16_t clx;
	int16_t cly;
	int size;
	GLuint id;
} used_textures[MAXTEXTURES];

void
remove_textures(int x, int y, int ex, int ey)
{
	int i;

	for (i = 0; i < ntextures; i++)
		if (((x <= used_textures[i].tx && used_textures[i].tx < ex) ||
			 (x < used_textures[i].tx + used_textures[i].size &&
			 used_textures[i].tx + used_textures[i].size <= ex)) &&
			/* we have X in */
			((y <= used_textures[i].ty && used_textures[i].ty < ey) ||
			 (y < used_textures[i].ty + 256 && 
			  used_textures[i].ty + 256 <= ey))) {

			/* we have both in */
			ntextures--;
#ifdef DEBUG_TEXTURE
			printf("gl.c: remove_textures: Hi, I just removed %d texture\n",
				   used_textures[i].id);
#endif
			glDeleteTextures(1, &used_textures[i].id);
			used_textures[i] = used_textures[ntextures];
			used_textures[ntextures].id = 0;
		}
}

/* XXX przerobic zeby pobierac adres w pamieci CLUT'a */
/* zamiast indeksow */
/*static*/ void
prepare_texture(int tx, int ty, int clx, int cly, int type)
{
	GLfloat texture_data[196608];
	int i, j, k;
	void print_matrices(void);
	/* FILE *file; */

	/* texture assertions */
	assert(ty <= MAXY - 256);
	assert((type == 0 && tx <= MAXX - 64) || (type == 1 && tx <= MAXX - 128)
		   || tx <= MAXX - 256);
	/* color table assertions */
	assert((type == 0 && clx <= MAXX - 16) ||
		   (type == 1 && clx <= MAXX - 256) || type > 1);
	assert(cly < MAXY);

#if 0
	printf("gl.c: prepare_texture: tx=%d ty=%d clx=%d cly=%d type=%d\n",
		   tx, ty, clx, cly, type);
	__asm__("int $3\n");
#endif
	
	for (i = 0; i < ntextures; i++)
		if (used_textures[i].id && tx == used_textures[i].tx
			&& ty == used_textures[i].ty &&
			used_textures[i].clx == clx &&
			used_textures[i].cly == cly) {
			glBindTexture(GL_TEXTURE_2D, used_textures[i].id);

			return;
		}
	if (i == MAXTEXTURES) {
		/* we have exhaused all available memory... */
#ifdef DEBUG_TEXTURE
		puts("gl.c: prepare_texture: Cannot allocate additional texture");
#endif

		return;
	}
	ntextures++;
	glGenTextures(1, &used_textures[i].id);
#ifdef DEBUG_TEXTURE
	printf("gl.c: prepare_textures: Allocating %d additional texture.\n",
		   used_textures[i].id);
#endif
	glBindTexture(GL_TEXTURE_2D, used_textures[i].id);
	used_textures[i].tx = tx;
	used_textures[i].ty = ty;
	used_textures[i].clx = clx;
	used_textures[i].cly = cly;

	bzero(texture_data, sizeof(texture_data));
	switch (type) {
	default:
		used_textures[i].size = 256;
		/* we have to convert data in 5-bit/color format to full */
		/* 8-bits */
		for (j = 0, k = 0; j < 256; j++)
			for (i = 0; i < 256; i++) {
#if 1
				__asm__("int $3\n");
				printf("15-bit direct: 0x%x\n", vram[tx + i][ty + j]);
#endif
				texture_data[k++] = ((vram[tx + i][ty + j] & 0x7c00) >> 10)/31.;
				texture_data[k++] = ((vram[tx + i][ty + j] & 0x3e0) >> 5)/31.;
				texture_data[k++] = (vram[tx + i][ty + j] & 0x1f)/31.;
			}
#if 1
	case 0:
		used_textures[i].size = 64;
		/* we use a 4-bit lookup to CLUT table */
		/* file = fopen("dump2.bin", "w");
		for (j = 0; j < 256; j++)
			for (i = 0; i < 64; i++) {
				fputc(vram[tx + i][ty + j] & 0xff, file);
				fputc(vram[tx + i][ty + j] & 0xff00 >> 8, file);
			}
		*/
		for (j = 0, k = 0; j < 256; j++)
			for (i = 0; i < 64; i++) {
				uint16_t mask, shift;
				uint16_t addr = vram[tx + i][ty + j];

#if 0
				printf("the frightening value is....!:= 0x%.4x\n", addr); 
#endif
				for (mask = 0xf, shift = 0; mask; mask <<= 4, shift += 4) {
					uint16_t word = vram[clx + ((addr & mask) >> shift)][cly];
#if 0
					printf("color index: %d\n", ((addr & mask) >> shift));
#endif

					texture_data[k++] = ((word & 0x7c00) >> 10)/31.;
					texture_data[k++] = ((word & 0x3e0) >> 5)/31.;
					texture_data[k++] = (word & 0x1f)/31.;
				}
			}
		break;
	case 1:
#if 1
		used_textures[i].size = 128;
		/* we use a 8-bit lookup to CLUT table */
		for (j = 0, k = 0; j < 256; j++)
			for (i = 0; i < 128; i++) {
				uint16_t mask, shift;
				uint16_t addr = vram[tx + i][ty + j];

				for (mask = 0xff, shift = 0; mask; mask <<= 8, shift += 8) {
					uint16_t word = vram[clx + ((addr & mask) >> shift)][cly];
#if 0
					__asm__("int $3\n");
					printf("8 - bit CLUT: 0x%x\n", word);
#endif
					texture_data[k++] = ((word & 0x7c00) >> 10)/31.;
					texture_data[k++] = ((word & 0x3e0) >> 5)/31.;
					texture_data[k++] = (word & 0x1f)/31.;
				}
			}
#endif
		break;
#endif
	}
#if 1
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
#else
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LEAREST);
#endif
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 256, 256, 0,
				 GL_BGR, GL_FLOAT, texture_data);
}

/* 3 point polygon */
static void
mono_3pp(input_t *data)
{
	int16_t x0 = data[1].w[0];
	int16_t y0 = data[1].w[1];
	int16_t x1 = data[2].w[0];
	int16_t y1 = data[2].w[1];
	int16_t x2 = data[3].w[0];
	int16_t y2 = data[3].w[1];

	glBegin(GL_TRIANGLES);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glVertex2s(x0, y0);
	glVertex2s(x1, y1);
	glVertex2s(x2, y2);
	glEnd();
}

static void
text_3pp(input_t *data)
{
	int16_t x0 = data[1].w[0], y0 = data[1].w[1];
	uint16_t clutid = data[2].w[1];
	uint8_t u0 = data[2].b[3], v0 = data[2].b[2];
	int16_t x1 = data[3].w[0], y1 = data[3].w[1];
	uint16_t tpage = data[4].w[1];
	uint8_t u1 = data[4].b[3], v1 = data[4].b[2];
	int16_t x2 = data[5].w[0], y2 = data[5].w[1];
	uint8_t u2 = data[6].b[3], v2 = data[6].b[2];
	int cl_data_x = (clutid & 0x3f) << 4;
	int cl_data_y = (clutid & 0xffc0) >> 6;
	int tp_data_x = (tpage & 0xf) << 6;
	int tp_data_y = tpage & 0x10 ? 256 : 0;
	int clut_type = (tpage & 0x180) >> 7;

	global_tpx = tp_data_x;
	global_tpy = tp_data_y;
	global_clut_type = clut_type;

	glEnable(GL_TEXTURE_2D);
	prepare_texture(tp_data_x, tp_data_y, cl_data_x, cl_data_y, clut_type);
	glBegin(GL_TRIANGLES);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glTexCoord2f(u0/255., v0/255.);
	glVertex2s(x0, y0);
	glTexCoord2f(u1/255., v1/255.);
	glVertex2s(x1, y1);
	glTexCoord2f(u2/255., v2/255.);
	glVertex2s(x2, y2);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

/* 4 point polygon */
static void
mono_4pp(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	int16_t y1 = data[2].w[1], x1 = data[2].w[0];
	int16_t y2 = data[3].w[1], x2 = data[3].w[0];
	int16_t y3 = data[4].w[1], x3 = data[4].w[0];
	/*
	print_matrices();
	__asm__("int $3\n");
	*/
	glBegin(GL_QUADS);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glVertex2s(x0, y0);
	glVertex2s(x1, y1);
	glVertex2s(x3, y3);
	glVertex2s(x2, y2);
	glEnd();
}

/* textured 4 point polygon */
static void
text_4pp(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	uint16_t clutid = data[2].w[1];
	uint8_t u0 = data[2].b[0], v0 = data[2].b[1];
	int16_t y1 = data[3].w[1], x1 = data[3].w[0];
	uint16_t tpage = data[4].w[1];
	uint8_t u1 = data[4].b[0], v1 = data[4].b[1];
	int16_t y2 = data[5].w[1], x2 = data[5].w[0];
	uint8_t u2 = data[6].b[0], v2 = data[6].b[1];
	int16_t y3 = data[7].w[1], x3 = data[7].w[0];
	uint8_t u3 = data[8].b[0], v3 = data[8].b[1];
	/* XXX przesniesc obliczanie TP i CLUT'a do funkcji prepare_texture */
	int clut_data_x = (clutid & 0x3f) << 4;
	int clut_data_y = (clutid & 0xffc0) >> 6;
	int tp_data_x = (tpage & 0xf) << 6;
	int tp_data_y = tpage & 0x10 ? 256 : 0;
	int clut_type = (tpage & 0x180) >> 7;

	global_tpx = tp_data_x;
	global_tpy = tp_data_y;
	global_clut_type = clut_type;

	prepare_texture(tp_data_x, tp_data_y, clut_data_x, clut_data_y, clut_type);
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor3f(data[0].b[0], data[0].b[1], data[0].b[2]);
	glTexCoord2f(u0/255., v0/255.);
	glVertex2s(x0, y0);
	glTexCoord2f(u1/255., v1/255.);
	glVertex2s(x1, y1);
	glTexCoord2f(u3/255., v3/255.);
	glVertex2s(x3, y3);
	glTexCoord2f(u2/255., v2/255.);
	glVertex2s(x2, y2);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

/* goraud shaded 3 point polygon */
static void
grad_3pp(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	int16_t y1 = data[3].w[1], x1 = data[3].w[0];
	int16_t y2 = data[5].w[1], x2 = data[5].w[0];

	glBegin(GL_TRIANGLES);
	glColor3f(data[0].b[0], data[0].b[1], data[0].b[2]);
	glVertex2s(x0, y0);
	glColor3f(data[2].b[0], data[2].b[1], data[2].b[2]);
	glVertex2s(x1, y1);
	glColor3f(data[4].b[0], data[4].b[1], data[4].b[2]);
	glVertex2s(x2, y2);
	glEnd();
}

static void
grad_text_3pp(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	uint16_t clutid = data[2].w[1];
	uint8_t u0 = data[2].b[0], v0 = data[2].b[1];
	int16_t y1 = data[4].w[1], x1 = data[4].w[0];
	uint16_t tpage = data[5].w[1];
	uint8_t u1 = data[5].b[0], v1 = data[5].b[1];
	int16_t y2 = data[7].w[1], x2 = data[7].w[0];
	uint8_t u2 = data[8].b[0], v2 = data[8].b[1];
	int clut_data_x = (clutid & 0x3f) << 4;
	int clut_data_y = (clutid & 0xffc0) >> 6;
	int tp_data_x = (tpage & 0xf) << 6;
	int tp_data_y = tpage & 0x10 ? 256 : 0;
	int clut_type = (tpage & 0x180) >> 7;

	global_tpx = tp_data_x;
	global_tpy = tp_data_y;
	global_clut_type = clut_type;

	prepare_texture(clut_data_x, clut_data_y, tp_data_x, tp_data_y, clut_type);
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_TRIANGLES);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glTexCoord2f(u0/255., v0/255.);
	glVertex2s(x0, y0);
	glColor3ub(data[3].b[0], data[3].b[1], data[3].b[2]);
	glTexCoord2f(u1/255., v1/255.);
	glVertex2s(x1, y1);
	glColor3ub(data[6].b[0], data[6].b[1], data[6].b[2]);
	glTexCoord2f(u2/255., v2/255.);
	glVertex2s(x2, y2);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

static void
grad_4pp(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	int16_t y1 = data[3].w[1], x1 = data[3].w[0];
	int16_t y2 = data[5].w[1], x2 = data[6].w[0];
	int16_t y3 = data[7].w[1], x3 = data[7].w[0];

	glBegin(GL_QUADS);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glVertex2s(x0, y0);
	glColor3ub(data[2].b[0], data[0].b[1], data[2].b[2]);
	glVertex2s(x1, y1);
	glColor3ub(data[6].b[0], data[6].b[1], data[6].b[2]);
	glVertex2s(x3, y3);
	glColor3ub(data[4].b[0], data[4].b[1], data[4].b[2]);
	glVertex2s(x2, y2);
	glEnd();
}

static void
grad_text_4pp(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	uint16_t clutid = data[2].w[1];
	uint8_t u0 = data[2].b[3], v0 = data[2].b[2];
	int16_t y1 = data[4].w[1], x1 = data[4].w[0];
	uint16_t tpage = data[5].w[1];
	uint8_t u1 = data[5].b[0], v1 = data[5].b[1];
	int16_t y2 = data[7].w[1], x2 = data[7].w[0];
	uint8_t u2 = data[8].b[0], v2 = data[8].b[1];
	int16_t y3 = data[10].w[1], x3 = data[10].w[0];
	uint8_t u3 = data[11].b[0], v3 = data[11].b[1];
	int clut_data_x = (clutid & 0x3f) << 4;
	int clut_data_y = (clutid & 0xffc0) >> 6;
	int tp_data_x = (tpage & 0xf) << 6;
	int tp_data_y = tpage & 0x10 ? 256 : 0;
	int clut_type = (tpage & 0x180) >> 7;

	global_tpx = tp_data_x;
	global_tpy = tp_data_y;
	global_clut_type = clut_type;

	prepare_texture(clut_data_x, clut_data_y, tp_data_x, tp_data_y, clut_type);
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glTexCoord2f(u0/255., v0/255.);
	glVertex2s(x0, y0);
	glColor3ub(data[3].b[0], data[0].b[1], data[3].b[2]);
	glTexCoord2f(u1/255., v1/255.);
	glVertex2s(x1, y1);
	glColor3ub(data[9].b[0], data[9].b[1], data[9].b[2]);
	glTexCoord2f(u3/255., v3/255.);
	glVertex2s(x3, y3);
	glColor3ub(data[6].b[0], data[6].b[1], data[6].b[2]);
	glTexCoord2f(u2/255., v2/255.);
	glVertex2s(x2, y2);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

static void
mono_line(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	int16_t y1 = data[2].w[1], x1 = data[2].w[0];

	glBegin(GL_LINES);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glVertex2s(x0, y0);
	glVertex2s(x1, y1);
	glEnd();
}

/* mono-color multi-vertice line */
static void
mono_mult_line(input_t *data)
{
	glBegin(GL_LINE_STRIP);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	image_transfer = 4;
#ifdef DEBUG_POLYLINE
	puts("mono color polyline begin");
#endif
}

static void
grad_line(input_t *data)
{
	int16_t y0 = data[1].w[1], x0 = data[1].w[0];
	int16_t y1 = data[3].w[1], x1 = data[3].w[0];

	glBegin(GL_LINES);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glVertex2s(x0, y0);
	glColor3ub(data[2].b[0], data[2].b[1], data[2].b[2]);
	glVertex2s(x1, y1);
	glEnd();
}

static void
grad_mult_line(input_t *data)
{
	glBegin(GL_LINE_STRIP);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	image_transfer = 5;
#ifdef DEBUG_POLYLINE
	puts("multi color polyline begin");
#endif
}

static void
rectangle(input_t *data)
{
	int16_t x = data[1].w[0];
	int16_t y = data[1].w[1];
	int16_t w = data[2].w[0];
	int16_t h = data[2].w[1];

	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glRects(x, y, x + w, y + h);
}

static void
sprite(input_t *data)
{
	int16_t x = data[1].w[0];
	int16_t y = data[1].w[1];
	uint32_t clutid = data[2].w[1];
	uint16_t u = data[2].b[0], v = data[2].b[1];
	int16_t w = data[3].w[0];
	int16_t h = data[3].w[1];
	int clut_data_x = (clutid & 0x3f) << 4;
	int clut_data_y = (clutid & 0xffc0) >> 6;
	float alpha;

	if (data[0].b[0] & 2) {
		/* semi transparency on */
		glEnable(GL_BLEND);
		puts("warn: SEMI transparency ON!");
	}
	else
		glDisable(GL_BLEND);
	switch (global_abr) {
	case 0:
		glBlendFunc(GL_SRC_ALPHA, GL_SRC_ALPHA);
		alpha = 0.5; 
		break;
	case 1:
		glBlendFunc(GL_ONE, GL_ONE);
		break;
	case 2:
		glBlendFunc(GL_ONE, GL_SRC_ALPHA);
		alpha = -1;
		break;
	case 3:
		glBlendFunc(GL_ONE, GL_SRC_ALPHA);
		alpha = 0.25;
		break;
	}
	prepare_texture(global_tpx, global_tpy, clut_data_x,
				  clut_data_y, global_clut_type);
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor4f(data[0].b[0]/255., data[0].b[1]/255., data[0].b[2]/255., alpha);
	glTexCoord2f(u/255., v/255.);
	glVertex2s(x, y);
	glTexCoord2f(u/255., (v + h)/255.);
	glVertex2s(x, y + h);
	glTexCoord2f((u + w)/255., (v + h)/255.);
	glVertex2s(x + w, y + h);
	glTexCoord2f((u + w)/255., v/255.);
	glVertex2s(x + w, y);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

static void
dot(input_t *data)
{
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
#if 1
	glBegin(GL_POINTS);
	glVertex2s(data[1].w[0], data[1].w[1]);
	glEnd();
#else
	glRects(data[1].w[0], data[1].w[1], data[1].w[0] + 1, data[1].w[1]);
#endif
}

static void
rectangle_8_8(input_t *data)
{
	int16_t x = data[1].w[0];
	int16_t y = data[1].w[1];

	glBegin(GL_QUADS);
	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glRects(x, y, x + 8, y + 8);
	glEnd();
}

static void
sprite_8_8(input_t *data)
{
	int16_t x = data[1].w[0];
	int16_t y = data[1].w[1];
	uint16_t clutid = data[2].w[1];
	uint8_t u = data[2].b[0], v = data[2].b[1];
	int cl_data_x = (clutid & 0xf) << 4;
	int cl_data_y = (clutid & 0xffc0) >> 6;
	float alpha;

	if (data[0].b[0] & 2)
		/* semi transparency on */
		glEnable(GL_BLEND);
	else
		glDisable(GL_BLEND);
	switch (global_abr) {
	case 0:
		glBlendFunc(GL_SRC_ALPHA, GL_SRC_ALPHA);
		alpha = 0.5; 
		break;
	case 1:
		glBlendFunc(GL_ONE, GL_ONE);
		break;
	case 2:
		glBlendFunc(GL_ONE, GL_SRC_ALPHA);
		alpha = -1;
		break;
	case 3:
		glBlendFunc(GL_ONE, GL_SRC_ALPHA);
		alpha = 0.25;
		break;
	}
	prepare_texture(global_tpx, global_tpy, cl_data_x,
					cl_data_y, global_clut_type);
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor4f(data[0].b[0]/255., data[0].b[1]/255., data[0].b[2]/255., alpha);
	glTexCoord2s(u, v);
	glVertex2s(x, y);
	glTexCoord2s(u, (v + 8)/255.);
	glVertex2s(x, y + 8);
	glTexCoord2s((u + 8)/255., (v + 8)/255.);
	glVertex2s(x + 8, y + 8);
	glTexCoord2s((u + 8)/255., v);
	glVertex2s(x + 8, y);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

static void
rectangle_16_16(input_t *data)
{
	int16_t x = data[1].w[0];
	int16_t y = data[1].w[1];

	glColor3ub(data[0].b[0], data[0].b[1], data[0].b[2]);
	glRects(x, y, x + 16, y + 16);
}

static void
sprite_16_16(input_t *data)
{
	int16_t x = data[1].w[0];
	int16_t y = data[1].w[1];
	uint32_t clutid = data[2].w[1];
	uint16_t u = data[2].b[0], v = data[2].b[1];
	int cl_data_x = (clutid & 0xf) << 4;
	int cl_data_y = (clutid & 0xffc0) >> 6;
	float alpha;

	if (data[0].b[0] & 2)
		/* semi transparency on */
		glEnable(GL_BLEND);
	else
		glDisable(GL_BLEND);
	switch (global_abr) {
	case 0:
		glBlendFunc(GL_SRC_ALPHA, GL_SRC_ALPHA);
		alpha = 0.5; 
		break;
	case 1:
		glBlendFunc(GL_ONE, GL_ONE);
		break;
	case 2:
		glBlendFunc(GL_ONE, GL_SRC_ALPHA);
		alpha = -1;
		break;
	case 3:
		glBlendFunc(GL_ONE, GL_SRC_ALPHA);
		alpha = 0.25;
		break;
	}
	prepare_texture(global_tpx, global_tpy, cl_data_x,
				  cl_data_y, global_clut_type);
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor4f(data[0].b[0]/255., data[0].b[1]/255., data[0].b[2]/255., alpha);
	glTexCoord2f(u/255., v/255.);
	glVertex2s(x, y);
	glTexCoord2f(u/255., (v + 16)/255.);
	glVertex2s(x, y + 16);
	glTexCoord2f((u + 16)/255., (v + 16)/255.);
	glVertex2s(x + 16, y + 16);
	glTexCoord2f((u + 16)/255., v/255.);
	glVertex2s(x + 16, y);
	glEnd();
	glDisable(GL_TEXTURE_2D);
}

/* -1 = wait for termination code */
int8_t command_length[] = {
	/* GPU commands */
   	1, 1, 3, 0, 0, 0, 0, 0,		/* 0x00 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0x08 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0x10 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0x18 */
	/* primitive drawing */
	/* 3 point polygon */
	4, 0, 0, 0, 7, 0, 0, 0,		/* 0x20 */
	/* 4 point polygon */
	5, 0, 5, 0, 9, 9, 9, 0,		/* 0x28 */
	/* 3 point polygon */
	6, 0, 0, 0, 9, 0, 0, 0,		/* 0x30 */
	/* 4 point polygon */
	8, 0, 8, 0, 12, 0, 0, 0,	/* 0x38 */
	/* monochrome line */
	3, 0, 3, 0, 0, 0, 0, 0,		/* 0x40 */
	1, 0, 0, 0, 0, 0, 0, 0,	/* 0x48 */
	/* goraud shaded line */
	4, 0, 0, 0, 0, 0, 0, 0,		/* 0x50 */
	2, 0, 0, 0, 2, 0, 0, 0,	/* 0x58 */
	/* rectangle and sprite */
	3, 0, 0, 0, 4, 4, 4, 0,		/* 0x60 */
	/* dot */
	2, 0, 0, 0, 0, 0, 0, 0,		/* 0x68 */
	/* rectangle and sprite */
	2, 0, 0, 0, 3, 0, 0, 0,		/* 0x70 */
	2, 0, 0, 0, 3, 0, 0, 0,		/* 0x78 */
	/* move image in GPU */
	4, 0, 0, 0, 0, 0, 0, 0,		/* 0x80 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0x88 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0x90 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0x98 */
	/* send image to frame buffer */
	3, 0, 0, 0, 0, 0, 0, 0,		/* 0xa0 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0xa8 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0xb0 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0xb8 */
	3, 0, 0, 0, 0, 0, 0, 0,		/* 0xc0 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0xc8 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0xd0 */
	0, 0, 0, 0, 0, 0, 0, 0,		/* 0xd8 */
	0, 1, 1, 1, 1, 1, 1, 0,		/* 0xe0 */
};

void (*function_dispatcher[])(input_t *) = {
	reset, clear_cache, frame_draw, NULL, NULL, NULL, NULL, NULL,		/* 0x00 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x08 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x10 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x18 */
	mono_3pp, NULL, NULL, NULL, text_3pp, NULL, NULL, NULL,		/* 0x20 */
	mono_4pp, NULL, mono_4pp, NULL, text_4pp, text_4pp, text_4pp, NULL,		/* 0x28 */
	grad_3pp, NULL, NULL, NULL, grad_text_3pp, NULL, NULL, NULL,		/* 0x30 */
	grad_4pp, NULL, grad_4pp, NULL, grad_text_4pp, NULL, NULL, NULL,		/* 0x38 */
	mono_line, NULL, mono_line, NULL, NULL, NULL, NULL, NULL,		/* 0x40 */
	mono_mult_line, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x48 */
	grad_line, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x50 */
	grad_mult_line, NULL, NULL, NULL, grad_mult_line, NULL, NULL, NULL,		/* 0x58 */
	rectangle, NULL, NULL, NULL, sprite, sprite, sprite, NULL,		/* 0x60 */
	dot, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x68 */
	rectangle_8_8, NULL, NULL, NULL, sprite_8_8, NULL, NULL, NULL,		/* 0x70 */
	rectangle_16_16, NULL, NULL, NULL, sprite_16_16, NULL, NULL, NULL,		/* 0x78 */
	move_image, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x80 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x88 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x90 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0x98 */
	put_image, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xa0 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xa8 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xb0 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xb8 */
	get_image, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xc0 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xc8 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xd0 */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,		/* 0xd8 */
	NULL, texture_page, texture_window, darea_tl, darea_br, darea_of, set_mask, NULL,		/* 0xe0 */
};
